/* Peek into a user's actions on the bbs.
 * This allows you to follow all stuff, and also
 * send messages and initiate chats...
 * (C) 1994, Johan. K. Reinalda, WG7J
 */
#include <ctype.h>
#include "global.h"
#ifdef LOOKSESSION
#include "session.h"
#include "smtp.h"
#include "usock.h"
#include "socket.h"
#include "mailbox.h"
  
static void look_input __ARGS((int unused,void *p1,void *p2));
  
int dolook(int argc, char *argv[],void *p) {
    struct session *sp;
    struct usock *up;
    int s,user,chat,index,quit;
    char c,*cp;
    struct mbx *m;
    char buf[MBXLINE];
  
    /* Check if this comes from console - WG7J*/
    if(Curproc->input != Command->input)
        return 0;
  
    /* Find the user ! */
    for(m=Mbox;m;m=m->next)
        if(!stricmp(m->name,argv[1]))
            break;
    if(!m) {
        tprintf("'%s' not a mailbox user!\n",argv[1]);
        return 0;
    }
    if((up = itop(m->user)) == NULLUSOCK){
        tputs("User socket error!\n");
        return 0;
    }
    if(up->look) {
        tprintf("Already looking at %s\n",argv[1]);
        return 0;
    }
  
    /* Now everything seems okay ! Get a session */
    if((sp = newsession(argv[1],LOOK,1)) == NULLSESSION) {
        tputs(TooManySessions);
        return 0;
    }
  
    up->look = Curproc;     /* Tell the socket to echo data to this process ! */
//    sp->s = sp->input;      /* so that doclose() will work ! */
    user = m->user;
    chat = 0;
    index = sp - Sessions;
  
    tprintf("%s session %d looking at %s\n", Sestypes[sp->type],index,argv[1]);
  
    /* Process whatever's typed on the terminal */
    memset(buf,0,MBXLINE);   /* Clear the input buffer */
    while(recvline(Curproc->input,buf,sizeof(buf)-1) >= 0) {
        if(buf[0] == '/') {
            /* process commands */
            quit = 0;
            switch(tolower(buf[1])) {
                case 'h':
                case '?':
                    tprintf("<Cmds>: /c-chat /m-msg /q-quit\n");
                    break;
                case 'm':   /* Send a message to the user */
                    cp = &buf[2];
                    if(buf[2] == ' ')
                        cp = &buf[3];
                    usprintf(user,"<sysop>: %s",cp);
                    break;
                case 'c':   /* Initiate chat mode */
                    if(chat)    /* Already in 'chat mode' */
                        break;
                    usputs(user,"*** SYSOP Initiated CHAT.\n");
                    up->look = NULL;    /* Disable echoing in socket layer */
                /* Now we need to redirect the network input
                 * from the user's bbs process to the chat process
                 */
                    sp->proc1 = newproc("CHAT Server",1024,look_input,0,
                    (void *)sp,(void *)m,0);
                    chat = 1;
                    break;
                case 'b':
                case 'q':   /* quit chat mode, or look mode */
                    if(chat) {
                        killproc(sp->proc1);
                        sp->proc1 = NULLPROC;
                        up->look = Curproc; /* Enable echoing in socket layer */
                        usputs(user,"*** BACK in mailbox.\n");
                        resume(m->proc);
                        chat = 0;
                    } else
                        goto done;
                    break;
            }
        } else if(chat)
            usprintf(user,"<sysop>: %s",buf);
  
        usflush(user);
        usflush(Curproc->output);
        memset(buf,0,MBXLINE);   /* Clear the input buffer */
    }
    done:
    /* A 'close' command was given, or user disconnected.
     * Notify the user, kill the receiver input task and wait for a response
     * from the user before freeing the session.
     */
    cp = sockerr(sp->input);
    tprintf("%s session %u closed: %s\n",
    Sestypes[sp->type],index,
    cp != NULLCHAR ? cp : "EOF");
  
    if((up = itop(m->user)) != NULLUSOCK)   /* Make sure socket is still there */
        up->look = NULL;
    if(sp->proc1 != NULLPROC) {
        /* kill the receive process */
        killproc(sp->proc1);
        sp->proc1 = NULLPROC;
        usputs(m->user,"\007*** BACK in mailbox.\n");
        usflush(m->user);
        /* restart the mailbox process */
        resume(m->proc);
    }
    keywait(NULLCHAR,1);
    freesession(sp);
    return 0;
}
  
/* Task that read the user's input socket (that formerly went to the bbs
 * process), and sends it to the look session !
 */
void
look_input(unused,p1,p2)
int unused;
void *p1;
void *p2;
{
    struct session *sp;
    struct mbx *m;
    int input,output,c;
  
    sp = (struct session *)p1;
    m = (struct mbx *)p2;
  
    /* Suspend the bbs process until we're done talking */
    suspend(m->proc);
  
    /* Process input on the users socket connection */
    while((c = recvchar(m->user)) != -1)
        tputc((char)c);
  
    /* Make sure our parent doesn't try to kill us after we exit */
    sp->proc1 = NULLPROC;
  
    /* Alert the parent, in case the chat was terminated by losing the
     * user connection. This in effect will close the look session
     */
    alert(sp->proc,ENOTCONN);
  
    /* Resume the mailbox */
    resume(m->proc);
  
}
  
#endif /* LOOKSESSION */
  
